#![allow(unused_parens)]

use std::io::prelude::*;
use std::fs::File;
use std::env::args;

fn main()
{
	let argv = args().collect::<Vec<String>>();
	if argv.len() != 3
	{
		eprintln!("usage: differentiate <input.dat> <output.dat>");
		return;
	}

	let mut input = File::open(&argv[1]).unwrap();
	let mut data:Vec<f32> = Vec::new();
	loop
	{
		let mut buffer:[u8;4] = [0x00;4];
		match input.read_exact(&mut buffer)
		{
			Ok(_) => (),
			Err(_) => break,
		};
		data.push(f32::from_be_bytes(buffer));
	}

	let mut output:Vec<f32> = Vec::with_capacity(data.len());
	for i in 1..data.len()
	{
		output.push(data[i] - data[i-1]);
	}

	let mut output_file = File::create(&argv[2]).unwrap();
	let mut output_buffer:Vec<u8> = Vec::with_capacity(output.len() * 4);
	for &point in output.iter()
	{
		output_buffer.extend_from_slice(&point.to_be_bytes());
	}
	output_file.write_all(&output_buffer).unwrap();
}
