#![allow(unused_parens)]

use std::io::prelude::*;
use std::fs::File;
use std::env::args;

use std::f32::consts::PI;

fn main()
{
	let argv = args().collect::<Vec<String>>();
	if argv.len() != 5
	{
		eprintln!("usage: orthosine <wavenumber> <size> <output_i.dat> <output_q.dat>");
		return;
	}

	let wavenumber = argv[1].parse::<f32>().unwrap();
	let size = argv[2].parse::<usize>().unwrap();

	let mut idata = Vec::with_capacity(size);
	let mut qdata = Vec::with_capacity(size);

	for t in 0..size
	{
		let (i,q) = (wavenumber * PI * (t as f32) / (size as f32)).sin_cos();
		idata.append(&mut i.to_be_bytes().to_vec());
		qdata.append(&mut q.to_be_bytes().to_vec());
	}

	let mut output_i = File::create(&argv[3]).unwrap();
	let mut output_q = File::create(&argv[4]).unwrap();

	output_i.write_all(&idata).unwrap();
	output_q.write_all(&qdata).unwrap();
}
