#![allow(unused_parens)]

use std::io::prelude::*;
use std::fs::File;
use std::env::args;

fn main()
{
	let argv = args().collect::<Vec<String>>();
	if argv.len() != 5
	{
		eprintln!("usage: pad <pre> <post> <input.dat> <output.dat>");
		return;
	}

	let pre = argv[1].parse::<usize>().unwrap();
	let post = argv[2].parse::<usize>().unwrap();

	let mut input = File::open(&argv[3]).unwrap();
	let mut input_data:Vec<u8> = Vec::new();
	input.read_to_end(&mut input_data).unwrap();

	let mut output_data:Vec<u8> = Vec::with_capacity(input_data.len() + pre*4 + post*4);
	for _ in 0..pre
	{
		output_data.extend_from_slice(&0.0f32.to_be_bytes());
	}
	output_data.append(&mut input_data);
	for _ in 0..post
	{
		output_data.extend_from_slice(&0.0f32.to_be_bytes());
	}

	let mut output = File::create(&argv[4]).unwrap();
	output.write_all(&output_data).unwrap();
}
