#![allow(unused_parens)]

use std::io::prelude::*;
use std::fs::OpenOptions;
use std::io::SeekFrom;
use std::env::args;

fn main()
{
	let argv = args().collect::<Vec<String>>();
	if argv.len() != 2
	{
		eprintln!("no. arguments: <target.dat>");
		return;
	}

	let mut target = 
	(
		OpenOptions::new()
		.read(true)
		.write(true)
		.append(false)
		.truncate(false)
		.create(false)
		.create_new(false)
		.open(&argv[1])
		.unwrap()
	);

	let mut buffer:[u8;4] = [0x00;4];
	for i in 0..
	{
		let seek_try = target.seek(SeekFrom::Start(i * 4));
		if seek_try.is_err()
		{ 
			break; 
		}
		
		let read_try = target.read_exact(&mut buffer);
		if read_try.is_err()
		{ 
			break; 
		}

		buffer[0] &= 0b0111_1111;
		
		target.seek(SeekFrom::Start(i * 4)).unwrap();
		target.write_all(&buffer).unwrap();
	}
}
