use std::io::prelude::*;
use std::fs::File;
use std::env::args;

fn main()
{
	let argv = args().collect::<Vec<String>>();
	if argv.len() != 2
	{
		eprintln!("no. <input>");
		return;
	}

	let mut input_file = File::open(&argv[1]).unwrap();
	let mut file_string = String::new();
	input_file.read_to_string(&mut file_string).unwrap();

	let mut data:Vec<f32> = Vec::new();

	for nstr in file_string.split(|c| c == '\r' || c == '\n' || c == ' ')
	{
		if let Ok(n) = nstr.parse::<f32>() 
		{
			data.push(n);
		}
	}
	
	let mut max_val = data[0];
	let mut min_val = data[0];
	
	for &point in data.iter()
	{
		max_val = max_val.max(point);
		min_val = min_val.min(point);
	}

	let abs_max = max_val.abs().max(min_val.abs());

	for &unnorm_point in data.iter()
	{
		let light_point = (50.0 * unnorm_point.abs() / abs_max).round() as usize;
		let dark_point = 50 - light_point;
		if unnorm_point > 0.0
		{
			for _ in 0..50
			{
				print!(" ");
			}
			//print!("┣");
			print!("█");
			for _ in 0..light_point
			{
				//print!("━");
				print!("█");
			}
			for _ in 0..dark_point
			{
				print!(" ");
			}
			println!();
		}
		if unnorm_point < 0.0
		{
			for _ in 0..dark_point
			{
				print!(" ");
			}
			for _ in 0..light_point
			{
				//print!("━");
				print!("█");
			}
			//print!("┫");
			print!("█");
			for _ in 0..50
			{
				print!(" ");
			}
			println!();
		}
		if unnorm_point == 0.0
		{
			for _ in 0..50
			{
				print!(" ");
			}
			print!("┃");
			for _ in 0..50
			{
				print!(" ");
			}
			println!();
		}
	}

}
