#![allow(unused_parens)]

use std::io::prelude::*;
use std::fs::File;
use std::env::args;

use std::f32::consts::PI;

fn main()
{
	let argv = args().collect::<Vec<String>>();
	if argv.len() != 6
	{
		eprintln!("usage: zadoffchu <u> <q> <length> <i.dat> <q.dat>");
		return;
	}
	let param_u = argv[1].parse::<usize>().unwrap();
	let param_q = argv[2].parse::<usize>().unwrap();
	let param_l = argv[3].parse::<usize>().unwrap();
	let mut sin_file = File::create(&argv[4]).unwrap();
	let mut cos_file = File::create(&argv[5]).unwrap();

	let u = param_u as f32;
	let q = param_q as f32;
	let l = param_l as f32;
	let cf = l % 2.0;

	let mut sin_buffer:Vec<u8> = Vec::with_capacity(param_l * 4);
	let mut cos_buffer:Vec<u8> = Vec::with_capacity(param_l * 4);
	for i in 0..param_l
	{
		let t = i as f32;
		sin_buffer.extend_from_slice(
			&(
				(
					-1.0*PI*u*t
				) * (
					t + cf + 2.0*q
				) / (
					l
				)
			)
			.cos()
			.to_be_bytes()
		);
		cos_buffer.extend_from_slice(
			&(
				(
					-1.0*PI*u*t
				) * (
					t + cf + 2.0*q
				) / (
					l
				)
			)
			.sin()
			.to_be_bytes()
		);
	}
	sin_file.write_all(&sin_buffer).unwrap();
	cos_file.write_all(&cos_buffer).unwrap();
}
